/* dconf-update.c generated by valac 0.40.19, the Vala compiler
 * generated from dconf-update.vala, do not modify */

/*
 * Copyright © 2010 Codethink Limited
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the licence, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Ryan Lortie <desrt@desrt.ca>
 */


#include <glib.h>
#include <glib-object.h>
#include "../gvdb/gvdb-builder.h"
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <glib/gstdio.h>
#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



GvdbItem* get_parent (GHashTable* table,
                      const gchar* name);
GSList* list_directory (const gchar* dirname,
                        mode_t mode,
                        GError** error);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
GHashTable* read_locks_directory (const gchar* dirname,
                                  GError** error);
GHashTable* read_directory (const gchar* dirname,
                            GError** error);
time_t get_directory_mtime (const gchar* dirname,
                            struct stat* dir_buf,
                            GError** error);
void maybe_update_from_directory (const gchar* dirname,
                                  GError** error);
void update_all (const gchar* dirname,
                 GError** error);
void dconf_compile (gchar** args,
                    int args_length1,
                    GError** error);
void dconf_update (gchar** args,
                   int args_length1,
                   GError** error);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		offset = _tmp3_ + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		glong _tmp4_;
		_tmp4_ = string_length;
		g_return_val_if_fail (offset <= _tmp4_, NULL);
	}
	if (len < ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		len = _tmp5_ - offset;
	}
	_tmp6_ = string_length;
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp7_;
	return result;
}


GvdbItem*
get_parent (GHashTable* table,
            const gchar* name)
{
	GvdbItem* result = NULL;
	GvdbItem* parent = NULL;
	gint end = 0;
	gint _tmp5_;
	gchar* parent_name = NULL;
	gint _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gconstpointer _tmp9_;
	GvdbItem* _tmp10_;
	GvdbItem* _tmp16_;
	g_return_val_if_fail (table != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	end = 0;
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				if (!(string_get (name, (glong) _tmp2_) != '\0')) {
					break;
				}
				_tmp3_ = i;
				if (string_get (name, (glong) (_tmp3_ - 1)) == '/') {
					gint _tmp4_;
					_tmp4_ = i;
					end = _tmp4_;
				}
			}
		}
	}
	_tmp5_ = end;
	_vala_assert (_tmp5_ != 0, "end != 0");
	_tmp6_ = end;
	_tmp7_ = string_substring (name, (glong) 0, (glong) _tmp6_);
	parent_name = _tmp7_;
	_tmp8_ = parent_name;
	_tmp9_ = g_hash_table_lookup (table, _tmp8_);
	parent = (GvdbItem*) _tmp9_;
	_tmp10_ = parent;
	if (_tmp10_ == NULL) {
		const gchar* _tmp11_;
		GvdbItem* _tmp12_;
		GvdbItem* _tmp13_;
		const gchar* _tmp14_;
		GvdbItem* _tmp15_;
		_tmp11_ = parent_name;
		_tmp12_ = gvdb_hash_table_insert (table, _tmp11_);
		parent = _tmp12_;
		_tmp13_ = parent;
		_tmp14_ = parent_name;
		_tmp15_ = get_parent (table, _tmp14_);
		gvdb_item_set_parent (_tmp13_, _tmp15_);
	}
	_tmp16_ = parent;
	result = _tmp16_;
	_g_free0 (parent_name);
	return result;
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}


GSList*
list_directory (const gchar* dirname,
                mode_t mode,
                GError** error)
{
	GSList* result = NULL;
	GSList* list = NULL;
	GDir* dir = NULL;
	GDir* _tmp0_;
	const gchar* name = NULL;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (dirname != NULL, NULL);
	list = NULL;
	_tmp0_ = g_dir_open (dirname, (guint) 0, &_inner_error0_);
	dir = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		(list == NULL) ? NULL : (list = (_g_slist_free__g_free0_ (list), NULL));
		return NULL;
	}
	while (TRUE) {
		GDir* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* filename = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		struct stat buf = {0};
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		struct stat _tmp9_ = {0};
		gint _tmp10_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		_tmp1_ = dir;
		_tmp2_ = g_dir_read_name (_tmp1_);
		name = _tmp2_;
		_tmp3_ = name;
		if (!(_tmp3_ != NULL)) {
			break;
		}
		_tmp4_ = name;
		if (g_str_has_prefix (_tmp4_, ".")) {
			continue;
		}
		_tmp5_ = name;
		_tmp6_ = g_build_filename (dirname, _tmp5_, NULL);
		filename = _tmp6_;
		_tmp8_ = filename;
		_tmp10_ = stat (_tmp8_, &_tmp9_);
		buf = _tmp9_;
		if (_tmp10_ < 0) {
			_tmp7_ = TRUE;
		} else {
			struct stat _tmp11_;
			mode_t _tmp12_;
			_tmp11_ = buf;
			_tmp12_ = _tmp11_.st_mode;
			_tmp7_ = (_tmp12_ & S_IFMT) != mode;
		}
		if (_tmp7_) {
			_g_free0 (filename);
			continue;
		}
		_tmp13_ = filename;
		_tmp14_ = g_strdup (_tmp13_);
		list = g_slist_prepend (list, _tmp14_);
		_g_free0 (filename);
	}
	result = list;
	_g_dir_close0 (dir);
	return result;
}


GHashTable*
read_locks_directory (const gchar* dirname,
                      GError** error)
{
	GHashTable* result = NULL;
	GSList* files = NULL;
	GHashTable* table = NULL;
	GHashTable* _tmp3_;
	GSList* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (dirname != NULL, NULL);
	{
		GSList* _tmp0_ = NULL;
		GSList* _tmp1_;
		GSList* _tmp2_;
		_tmp1_ = list_directory (dirname, S_IFREG, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (g_error_matches (_inner_error0_, G_FILE_ERROR, G_FILE_ERROR_NOENT)) {
				goto __catch0_g_file_error_noent;
			}
			goto __finally0;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
		files = _tmp2_;
		(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_free0_ (_tmp0_), NULL));
	}
	goto __finally0;
	__catch0_g_file_error_noent:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		result = NULL;
		_g_error_free0 (e);
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
		return NULL;
	}
	_tmp3_ = gvdb_hash_table_new (NULL, NULL);
	table = _tmp3_;
	_tmp4_ = files;
	{
		GSList* filename_collection = NULL;
		GSList* filename_it = NULL;
		filename_collection = _tmp4_;
		for (filename_it = filename_collection; filename_it != NULL; filename_it = filename_it->next) {
			gchar* _tmp5_;
			gchar* filename = NULL;
			_tmp5_ = g_strdup ((const gchar*) filename_it->data);
			filename = _tmp5_;
			{
				gchar* contents = NULL;
				const gchar* _tmp6_;
				gchar* _tmp7_ = NULL;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				_tmp6_ = filename;
				g_file_get_contents (_tmp6_, &_tmp7_, NULL, &_inner_error0_);
				_g_free0 (contents);
				contents = _tmp7_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (contents);
					_g_free0 (filename);
					_g_hash_table_unref0 (table);
					(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
					return NULL;
				}
				_tmp8_ = contents;
				_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, "\n", 0);
				{
					gchar** line_collection = NULL;
					gint line_collection_length1 = 0;
					gint _line_collection_size_ = 0;
					gint line_it = 0;
					line_collection = _tmp10_;
					line_collection_length1 = _vala_array_length (_tmp9_);
					for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
						gchar* _tmp11_;
						gchar* line = NULL;
						_tmp11_ = g_strdup (line_collection[line_it]);
						line = _tmp11_;
						{
							const gchar* _tmp12_;
							_tmp12_ = line;
							if (g_str_has_prefix (_tmp12_, "/")) {
								GHashTable* _tmp13_;
								const gchar* _tmp14_;
								_tmp13_ = table;
								_tmp14_ = line;
								gvdb_hash_table_insert_string (_tmp13_, _tmp14_, "");
							}
							_g_free0 (line);
						}
					}
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
				}
				_g_free0 (contents);
				_g_free0 (filename);
			}
		}
	}
	result = table;
	(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
	return result;
}


static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


GHashTable*
read_directory (const gchar* dirname,
                GError** error)
{
	GHashTable* result = NULL;
	GHashTable* table = NULL;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	GSList* files = NULL;
	GSList* _tmp2_;
	GCompareFunc _tmp3_;
	GSList* _tmp4_;
	GHashTable* locks = NULL;
	gchar* _tmp76_;
	gchar* _tmp77_;
	GHashTable* _tmp78_;
	GHashTable* _tmp79_;
	GHashTable* _tmp80_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (dirname != NULL, NULL);
	_tmp0_ = gvdb_hash_table_new (NULL, NULL);
	table = _tmp0_;
	_tmp1_ = table;
	gvdb_hash_table_insert (_tmp1_, "/");
	_tmp2_ = list_directory (dirname, S_IFREG, &_inner_error0_);
	files = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_hash_table_unref0 (table);
		return NULL;
	}
	_tmp3_ = ((GCompareFunc) g_strcmp0);
	files = g_slist_sort (files, _tmp3_);
	files = g_slist_reverse (files);
	_tmp4_ = files;
	{
		GSList* filename_collection = NULL;
		GSList* filename_it = NULL;
		filename_collection = _tmp4_;
		for (filename_it = filename_collection; filename_it != NULL; filename_it = filename_it->next) {
			gchar* _tmp5_;
			gchar* filename = NULL;
			_tmp5_ = g_strdup ((const gchar*) filename_it->data);
			filename = _tmp5_;
			{
				GKeyFile* kf = NULL;
				GKeyFile* _tmp6_;
				_tmp6_ = g_key_file_new ();
				kf = _tmp6_;
				{
					GKeyFile* _tmp7_;
					const gchar* _tmp8_;
					_tmp7_ = kf;
					_tmp8_ = filename;
					g_key_file_load_from_file (_tmp7_, _tmp8_, G_KEY_FILE_NONE, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch1_g_error;
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GError* _tmp9_;
					const gchar* _tmp10_;
					GError* _tmp11_;
					const gchar* _tmp12_;
					gchar* _tmp13_;
					GError* _tmp14_;
					GError* _tmp15_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp9_ = e;
					_tmp10_ = filename;
					_tmp11_ = e;
					_tmp12_ = _tmp11_->message;
					_tmp13_ = g_strdup_printf ("warning: Failed to read keyfile '%s': %s", _tmp10_, _tmp12_);
					_g_free0 (_tmp9_->message);
					_tmp9_->message = _tmp13_;
					_tmp14_ = e;
					_tmp15_ = _g_error_copy0 (_tmp14_);
					_inner_error0_ = _tmp15_;
					_g_error_free0 (e);
					goto __finally1;
				}
				__finally1:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_key_file_unref0 (kf);
					_g_free0 (filename);
					(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
					_g_hash_table_unref0 (table);
					return NULL;
				}
				{
					GKeyFile* _tmp16_;
					gsize _tmp17_ = 0;
					gchar** _tmp18_;
					_tmp16_ = kf;
					_tmp18_ = g_key_file_get_groups (_tmp16_, &_tmp17_);
					{
						gchar** group_collection = NULL;
						gint group_collection_length1 = 0;
						gint _group_collection_size_ = 0;
						gint group_it = 0;
						group_collection = _tmp18_;
						group_collection_length1 = _tmp17_;
						for (group_it = 0; group_it < group_collection_length1; group_it = group_it + 1) {
							gchar* _tmp19_;
							gchar* group = NULL;
							_tmp19_ = g_strdup (group_collection[group_it]);
							group = _tmp19_;
							{
								gboolean _tmp20_ = FALSE;
								gboolean _tmp21_ = FALSE;
								const gchar* _tmp22_;
								gchar** _tmp28_ = NULL;
								GKeyFile* _tmp29_;
								const gchar* _tmp30_;
								gsize _tmp31_ = 0;
								gchar** _tmp32_;
								gint _tmp28__length1;
								gint __tmp28__size_;
								_tmp22_ = group;
								if (g_str_has_prefix (_tmp22_, "/")) {
									_tmp21_ = TRUE;
								} else {
									const gchar* _tmp23_;
									_tmp23_ = group;
									_tmp21_ = g_str_has_suffix (_tmp23_, "/");
								}
								if (_tmp21_) {
									_tmp20_ = TRUE;
								} else {
									const gchar* _tmp24_;
									_tmp24_ = group;
									_tmp20_ = string_contains (_tmp24_, "//");
								}
								if (_tmp20_) {
									FILE* _tmp25_;
									const gchar* _tmp26_;
									const gchar* _tmp27_;
									_tmp25_ = stderr;
									_tmp26_ = filename;
									_tmp27_ = group;
									fprintf (_tmp25_, "%s: ignoring invalid group name: %s\n", _tmp26_, _tmp27_);
									_g_free0 (group);
									continue;
								}
								_tmp29_ = kf;
								_tmp30_ = group;
								_tmp32_ = g_key_file_get_keys (_tmp29_, _tmp30_, &_tmp31_, &_inner_error0_);
								_tmp28_ = _tmp32_;
								_tmp28__length1 = _tmp31_;
								__tmp28__size_ = _tmp28__length1;
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
									_g_free0 (group);
									group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
									if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
										goto __catch2_g_key_file_error;
									}
									_g_key_file_unref0 (kf);
									_g_free0 (filename);
									(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
									_g_hash_table_unref0 (table);
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return NULL;
								}
								{
									gchar** key_collection = NULL;
									gint key_collection_length1 = 0;
									gint _key_collection_size_ = 0;
									gint key_it = 0;
									key_collection = _tmp28_;
									key_collection_length1 = _tmp28__length1;
									for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
										gchar* _tmp33_;
										gchar* key = NULL;
										_tmp33_ = g_strdup (key_collection[key_it]);
										key = _tmp33_;
										{
											const gchar* _tmp34_;
											gchar* path = NULL;
											const gchar* _tmp39_;
											gchar* _tmp40_;
											gchar* _tmp41_;
											gchar* _tmp42_;
											gchar* _tmp43_;
											const gchar* _tmp44_;
											gchar* _tmp45_;
											gchar* _tmp46_;
											GHashTable* _tmp47_;
											const gchar* _tmp48_;
											gconstpointer _tmp49_;
											gchar* text = NULL;
											GKeyFile* _tmp50_;
											const gchar* _tmp51_;
											const gchar* _tmp52_;
											gchar* _tmp53_;
											_tmp34_ = key;
											if (string_contains (_tmp34_, "/")) {
												const gchar* _tmp35_;
												const gchar* _tmp36_;
												const gchar* _tmp37_;
												GError* _tmp38_;
												_tmp35_ = filename;
												_tmp36_ = group;
												_tmp37_ = key;
												_tmp38_ = g_error_new (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, "%s: [%s]: invalid key name: %s", _tmp35_, _tmp36_, _tmp37_);
												_inner_error0_ = _tmp38_;
												_g_free0 (key);
												_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
												_g_free0 (group);
												group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
												if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
													goto __catch2_g_key_file_error;
												}
												_g_key_file_unref0 (kf);
												_g_free0 (filename);
												(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
												_g_hash_table_unref0 (table);
												g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
												g_clear_error (&_inner_error0_);
												return NULL;
											}
											_tmp39_ = group;
											_tmp40_ = g_strconcat ("/", _tmp39_, NULL);
											_tmp41_ = _tmp40_;
											_tmp42_ = g_strconcat (_tmp41_, "/", NULL);
											_tmp43_ = _tmp42_;
											_tmp44_ = key;
											_tmp45_ = g_strconcat (_tmp43_, _tmp44_, NULL);
											_tmp46_ = _tmp45_;
											_g_free0 (_tmp43_);
											_g_free0 (_tmp41_);
											path = _tmp46_;
											_tmp47_ = table;
											_tmp48_ = path;
											_tmp49_ = g_hash_table_lookup (_tmp47_, _tmp48_);
											if (((GvdbItem*) _tmp49_) != NULL) {
												_g_free0 (path);
												_g_free0 (key);
												continue;
											}
											_tmp50_ = kf;
											_tmp51_ = group;
											_tmp52_ = key;
											_tmp53_ = g_key_file_get_value (_tmp50_, _tmp51_, _tmp52_, &_inner_error0_);
											text = _tmp53_;
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
												_g_free0 (path);
												_g_free0 (key);
												_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
												_g_free0 (group);
												group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
												if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
													goto __catch2_g_key_file_error;
												}
												_g_key_file_unref0 (kf);
												_g_free0 (filename);
												(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
												_g_hash_table_unref0 (table);
												g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
												g_clear_error (&_inner_error0_);
												return NULL;
											}
											{
												GVariant* value = NULL;
												const gchar* _tmp54_;
												GVariant* _tmp55_;
												GvdbItem* item = NULL;
												GHashTable* _tmp56_;
												const gchar* _tmp57_;
												GvdbItem* _tmp58_;
												GvdbItem* _tmp59_;
												GHashTable* _tmp60_;
												const gchar* _tmp61_;
												GvdbItem* _tmp62_;
												GvdbItem* _tmp63_;
												GVariant* _tmp64_;
												_tmp54_ = text;
												_tmp55_ = g_variant_parse (NULL, _tmp54_, NULL, NULL, &_inner_error0_);
												value = _tmp55_;
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
													if (_inner_error0_->domain == G_VARIANT_PARSE_ERROR) {
														goto __catch3_g_variant_parse_error;
													}
													_g_free0 (text);
													_g_free0 (path);
													_g_free0 (key);
													_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
													_g_free0 (group);
													group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
													_g_key_file_unref0 (kf);
													_g_free0 (filename);
													(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
													_g_hash_table_unref0 (table);
													g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
													g_clear_error (&_inner_error0_);
													return NULL;
												}
												_tmp56_ = table;
												_tmp57_ = path;
												_tmp58_ = gvdb_hash_table_insert (_tmp56_, _tmp57_);
												item = _tmp58_;
												_tmp59_ = item;
												_tmp60_ = table;
												_tmp61_ = path;
												_tmp62_ = get_parent (_tmp60_, _tmp61_);
												gvdb_item_set_parent (_tmp59_, _tmp62_);
												_tmp63_ = item;
												_tmp64_ = value;
												gvdb_item_set_value (_tmp63_, _tmp64_);
												_g_variant_unref0 (value);
											}
											goto __finally3;
											__catch3_g_variant_parse_error:
											{
												GError* e = NULL;
												GError* _tmp65_;
												const gchar* _tmp66_;
												const gchar* _tmp67_;
												const gchar* _tmp68_;
												const gchar* _tmp69_;
												GError* _tmp70_;
												const gchar* _tmp71_;
												gchar* _tmp72_;
												GError* _tmp73_;
												GError* _tmp74_;
												e = _inner_error0_;
												_inner_error0_ = NULL;
												_tmp65_ = e;
												_tmp66_ = filename;
												_tmp67_ = group;
												_tmp68_ = key;
												_tmp69_ = text;
												_tmp70_ = e;
												_tmp71_ = _tmp70_->message;
												_tmp72_ = g_strdup_printf ("%s: [%s]: %s: invalid value: %s (%s)", _tmp66_, _tmp67_, _tmp68_, _tmp69_, _tmp71_);
												_g_free0 (_tmp65_->message);
												_tmp65_->message = _tmp72_;
												_tmp73_ = e;
												_tmp74_ = _g_error_copy0 (_tmp73_);
												_inner_error0_ = _tmp74_;
												_g_error_free0 (e);
												goto __finally3;
											}
											__finally3:
											if (G_UNLIKELY (_inner_error0_ != NULL)) {
												_g_free0 (text);
												_g_free0 (path);
												_g_free0 (key);
												_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
												_g_free0 (group);
												group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
												if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
													goto __catch2_g_key_file_error;
												}
												goto __finally2;
											}
											_g_free0 (text);
											_g_free0 (path);
											_g_free0 (key);
										}
									}
								}
								_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
								_g_free0 (group);
							}
						}
						group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
					}
				}
				goto __finally2;
				__catch2_g_key_file_error:
				{
					GError* e = NULL;
					const gchar* _tmp75_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp75_ = e->message;
					g_warning ("dconf-update.vala:150: unexpected keyfile error: %s.  Please file a bu" \
"g.", _tmp75_);
					g_assert_not_reached ();
					_g_error_free0 (e);
				}
				__finally2:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_key_file_unref0 (kf);
					_g_free0 (filename);
					(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
					_g_hash_table_unref0 (table);
					return NULL;
				}
				_g_key_file_unref0 (kf);
				_g_free0 (filename);
			}
		}
	}
	_tmp76_ = g_strconcat (dirname, "/locks", NULL);
	_tmp77_ = _tmp76_;
	_tmp78_ = read_locks_directory (_tmp77_, &_inner_error0_);
	_tmp79_ = _tmp78_;
	_g_free0 (_tmp77_);
	locks = _tmp79_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
		_g_hash_table_unref0 (table);
		return NULL;
	}
	_tmp80_ = locks;
	if (_tmp80_ != NULL) {
		GvdbItem* item = NULL;
		GHashTable* _tmp81_;
		GvdbItem* _tmp82_;
		GvdbItem* _tmp83_;
		GHashTable* _tmp84_;
		_tmp81_ = table;
		_tmp82_ = gvdb_hash_table_insert (_tmp81_, ".locks");
		item = _tmp82_;
		_tmp83_ = item;
		_tmp84_ = locks;
		gvdb_item_set_hash_table (_tmp83_, _tmp84_);
	}
	result = table;
	_g_hash_table_unref0 (locks);
	(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
	return result;
}


time_t
get_directory_mtime (const gchar* dirname,
                     struct stat* dir_buf,
                     GError** error)
{
	time_t result = 0;
	struct stat lockdir_buf = {0};
	struct stat file_buf = {0};
	time_t dir_mtime = 0;
	struct stat _tmp0_;
	time_t _tmp1_;
	GSList* files = NULL;
	GSList* _tmp2_;
	GCompareFunc _tmp4_;
	GSList* _tmp5_;
	gboolean _tmp16_ = FALSE;
	gchar* _tmp17_;
	gchar* _tmp18_;
	struct stat _tmp19_ = {0};
	gint _tmp20_;
	gboolean _tmp21_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (dirname != NULL, 0);
	g_return_val_if_fail (dir_buf != NULL, 0);
	_tmp0_ = *dir_buf;
	_tmp1_ = _tmp0_.st_mtime;
	dir_mtime = _tmp1_;
	_tmp2_ = list_directory (dirname, S_IFREG, &_inner_error0_);
	files = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		time_t _tmp3_ = 0;
		g_propagate_error (error, _inner_error0_);
		return _tmp3_;
	}
	_tmp4_ = ((GCompareFunc) g_strcmp0);
	files = g_slist_sort (files, _tmp4_);
	files = g_slist_reverse (files);
	_tmp5_ = files;
	{
		GSList* filename_collection = NULL;
		GSList* filename_it = NULL;
		filename_collection = _tmp5_;
		for (filename_it = filename_collection; filename_it != NULL; filename_it = filename_it->next) {
			gchar* _tmp6_;
			gchar* filename = NULL;
			_tmp6_ = g_strdup ((const gchar*) filename_it->data);
			filename = _tmp6_;
			{
				gboolean _tmp7_ = FALSE;
				const gchar* _tmp8_;
				struct stat _tmp9_ = {0};
				gint _tmp10_;
				_tmp8_ = filename;
				_tmp10_ = stat (_tmp8_, &_tmp9_);
				file_buf = _tmp9_;
				if (_tmp10_ == 0) {
					struct stat _tmp11_;
					time_t _tmp12_;
					time_t _tmp13_;
					_tmp11_ = file_buf;
					_tmp12_ = _tmp11_.st_mtime;
					_tmp13_ = dir_mtime;
					_tmp7_ = _tmp12_ > _tmp13_;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					struct stat _tmp14_;
					time_t _tmp15_;
					_tmp14_ = file_buf;
					_tmp15_ = _tmp14_.st_mtime;
					dir_mtime = _tmp15_;
				}
				_g_free0 (filename);
			}
		}
	}
	_tmp17_ = g_strconcat (dirname, "/locks", NULL);
	_tmp18_ = _tmp17_;
	_tmp20_ = stat (_tmp18_, &_tmp19_);
	lockdir_buf = _tmp19_;
	_tmp21_ = _tmp20_ == 0;
	_g_free0 (_tmp18_);
	if (_tmp21_) {
		struct stat _tmp22_;
		mode_t _tmp23_;
		_tmp22_ = lockdir_buf;
		_tmp23_ = _tmp22_.st_mode;
		_tmp16_ = S_ISDIR (_tmp23_);
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		struct stat _tmp24_;
		time_t _tmp25_;
		time_t _tmp26_;
		GSList* _tmp29_ = NULL;
		gchar* _tmp30_;
		gchar* _tmp31_;
		GSList* _tmp32_;
		GSList* _tmp33_;
		GSList* _tmp35_;
		GCompareFunc _tmp36_;
		GSList* _tmp37_;
		_tmp24_ = lockdir_buf;
		_tmp25_ = _tmp24_.st_mtime;
		_tmp26_ = dir_mtime;
		if (_tmp25_ > _tmp26_) {
			struct stat _tmp27_;
			time_t _tmp28_;
			_tmp27_ = lockdir_buf;
			_tmp28_ = _tmp27_.st_mtime;
			dir_mtime = _tmp28_;
		}
		_tmp30_ = g_strconcat (dirname, "/locks", NULL);
		_tmp31_ = _tmp30_;
		_tmp32_ = list_directory (_tmp31_, S_IFREG, &_inner_error0_);
		_tmp33_ = _tmp32_;
		_g_free0 (_tmp31_);
		_tmp29_ = _tmp33_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			time_t _tmp34_ = 0;
			g_propagate_error (error, _inner_error0_);
			(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
			return _tmp34_;
		}
		_tmp35_ = _tmp29_;
		_tmp29_ = NULL;
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
		files = _tmp35_;
		_tmp36_ = ((GCompareFunc) g_strcmp0);
		files = g_slist_sort (files, _tmp36_);
		files = g_slist_reverse (files);
		_tmp37_ = files;
		{
			GSList* filename_collection = NULL;
			GSList* filename_it = NULL;
			filename_collection = _tmp37_;
			for (filename_it = filename_collection; filename_it != NULL; filename_it = filename_it->next) {
				gchar* _tmp38_;
				gchar* filename = NULL;
				_tmp38_ = g_strdup ((const gchar*) filename_it->data);
				filename = _tmp38_;
				{
					gboolean _tmp39_ = FALSE;
					const gchar* _tmp40_;
					struct stat _tmp41_ = {0};
					gint _tmp42_;
					_tmp40_ = filename;
					_tmp42_ = stat (_tmp40_, &_tmp41_);
					file_buf = _tmp41_;
					if (_tmp42_ == 0) {
						struct stat _tmp43_;
						time_t _tmp44_;
						time_t _tmp45_;
						_tmp43_ = file_buf;
						_tmp44_ = _tmp43_.st_mtime;
						_tmp45_ = dir_mtime;
						_tmp39_ = _tmp44_ > _tmp45_;
					} else {
						_tmp39_ = FALSE;
					}
					if (_tmp39_) {
						struct stat _tmp46_;
						time_t _tmp47_;
						_tmp46_ = file_buf;
						_tmp47_ = _tmp46_.st_mtime;
						dir_mtime = _tmp47_;
					}
					_g_free0 (filename);
				}
			}
		}
		(_tmp29_ == NULL) ? NULL : (_tmp29_ = (_g_slist_free__g_free0_ (_tmp29_), NULL));
	}
	result = dir_mtime;
	(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
	return result;
}


void
maybe_update_from_directory (const gchar* dirname,
                             GError** error)
{
	struct stat dir_buf = {0};
	gboolean _tmp0_ = FALSE;
	struct stat _tmp1_ = {0};
	gint _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (dirname != NULL);
	_tmp2_ = stat (dirname, &_tmp1_);
	dir_buf = _tmp1_;
	if (_tmp2_ == 0) {
		struct stat _tmp3_;
		mode_t _tmp4_;
		_tmp3_ = dir_buf;
		_tmp4_ = _tmp3_.st_mode;
		_tmp0_ = S_ISDIR (_tmp4_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		struct stat file_buf = {0};
		gchar* filename = NULL;
		gint _tmp5_;
		gint _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		const gchar* _tmp9_;
		struct stat _tmp10_ = {0};
		gint _tmp11_;
		GHashTable* table = NULL;
		GHashTable* _tmp16_;
		gint fd = 0;
		const gchar* _tmp17_;
		gboolean _tmp18_ = FALSE;
		gint _tmp19_;
		_tmp5_ = strlen (dirname);
		_tmp6_ = _tmp5_;
		_tmp7_ = string_substring (dirname, (glong) 0, (glong) (_tmp6_ - 2));
		filename = _tmp7_;
		_tmp9_ = filename;
		_tmp11_ = stat (_tmp9_, &_tmp10_);
		file_buf = _tmp10_;
		if (_tmp11_ == 0) {
			time_t _tmp12_ = 0;
			struct stat _tmp13_;
			struct stat _tmp14_;
			time_t _tmp15_;
			_tmp13_ = dir_buf;
			_tmp12_ = get_directory_mtime (dirname, &_tmp13_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (filename);
				return;
			}
			_tmp14_ = file_buf;
			_tmp15_ = _tmp14_.st_mtime;
			_tmp8_ = _tmp15_ > _tmp12_;
		} else {
			_tmp8_ = FALSE;
		}
		if (_tmp8_) {
			_g_free0 (filename);
			return;
		}
		_tmp16_ = read_directory (dirname, &_inner_error0_);
		table = _tmp16_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (filename);
			return;
		}
		_tmp17_ = filename;
		fd = open (_tmp17_, O_WRONLY, (mode_t) 0);
		_tmp19_ = fd;
		if (_tmp19_ < 0) {
			gint _tmp20_;
			_tmp20_ = errno;
			_tmp18_ = _tmp20_ != ENOENT;
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			gint saved_error = 0;
			gint _tmp21_;
			const gchar* _tmp22_;
			gint _tmp23_;
			const gchar* _tmp24_;
			_tmp21_ = errno;
			saved_error = _tmp21_;
			_tmp22_ = filename;
			_tmp23_ = saved_error;
			_tmp24_ = g_strerror (_tmp23_);
			g_printerr ("warning: Failed to open '%s' for replacement: %s\n", _tmp22_, _tmp24_);
			_g_hash_table_unref0 (table);
			_g_free0 (filename);
			return;
		}
		{
			GHashTable* _tmp25_;
			const gchar* _tmp26_;
			gint _tmp27_;
			_tmp25_ = table;
			_tmp26_ = filename;
			gvdb_table_write_contents (_tmp25_, _tmp26_, FALSE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch4_g_error;
			}
			_tmp27_ = fd;
			if (_tmp27_ >= 0) {
				gint _tmp28_;
				_tmp28_ = fd;
				write (_tmp28_, "\0\0\0\0\0\0\0\0", (gsize) 8);
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
			GError* _tmp29_;
			const gchar* _tmp30_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp29_ = e;
			_tmp30_ = _tmp29_->message;
			g_printerr ("warning: %s\n", _tmp30_);
			_g_error_free0 (e);
			{
				GError* _inner_error0_ = NULL;
				gint _tmp31_;
				_tmp31_ = fd;
				if (_tmp31_ >= 0) {
					gint _tmp32_;
					_tmp32_ = fd;
					close (_tmp32_);
				}
			}
			_g_hash_table_unref0 (table);
			_g_free0 (filename);
			return;
		}
		__finally4:
		{
			GError* _inner_error1_ = NULL;
			gint _tmp33_;
			_tmp33_ = fd;
			if (_tmp33_ >= 0) {
				gint _tmp34_;
				_tmp34_ = fd;
				close (_tmp34_);
			}
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_hash_table_unref0 (table);
			_g_free0 (filename);
			return;
		}
		{
			GDBusConnection* system_bus = NULL;
			GDBusConnection* _tmp35_;
			GDBusConnection* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			GVariant* _tmp42_;
			GVariant* _tmp43_;
			GDBusConnection* _tmp44_;
			_tmp35_ = g_bus_get_sync (G_BUS_TYPE_SYSTEM, NULL, &_inner_error0_);
			system_bus = _tmp35_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch5_g_error;
			}
			_tmp36_ = system_bus;
			_tmp37_ = filename;
			_tmp38_ = g_path_get_basename (_tmp37_);
			_tmp39_ = _tmp38_;
			_tmp40_ = g_strconcat ("/ca/desrt/dconf/Writer/", _tmp39_, NULL);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_variant_new ("(s)", "/", NULL);
			g_variant_ref_sink (_tmp42_);
			_tmp43_ = _tmp42_;
			g_dbus_connection_emit_signal (_tmp36_, NULL, _tmp41_, "ca.desrt.dconf.Writer", "WritabilityNotify", _tmp43_, &_inner_error0_);
			_g_variant_unref0 (_tmp43_);
			_g_free0 (_tmp41_);
			_g_free0 (_tmp39_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (system_bus);
				goto __catch5_g_error;
			}
			_tmp44_ = system_bus;
			g_dbus_connection_flush_sync (_tmp44_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (system_bus);
				goto __catch5_g_error;
			}
			_g_object_unref0 (system_bus);
		}
		goto __finally5;
		__catch5_g_error:
		{
			g_clear_error (&_inner_error0_);
			_inner_error0_ = NULL;
		}
		__finally5:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_hash_table_unref0 (table);
			_g_free0 (filename);
			return;
		}
		_g_hash_table_unref0 (table);
		_g_free0 (filename);
	}
}


void
update_all (const gchar* dirname,
            GError** error)
{
	GSList* _tmp0_ = NULL;
	GSList* _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (dirname != NULL);
	_tmp1_ = list_directory (dirname, S_IFDIR, &_inner_error0_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	{
		GSList* name_collection = NULL;
		GSList* name_it = NULL;
		name_collection = _tmp0_;
		for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
			gchar* _tmp2_;
			gchar* name = NULL;
			_tmp2_ = g_strdup ((const gchar*) name_it->data);
			name = _tmp2_;
			{
				const gchar* _tmp3_;
				_tmp3_ = name;
				if (g_str_has_suffix (_tmp3_, ".d")) {
					{
						const gchar* _tmp4_;
						_tmp4_ = name;
						maybe_update_from_directory (_tmp4_, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch6_g_error;
						}
					}
					goto __finally6;
					__catch6_g_error:
					{
						GError* e = NULL;
						const gchar* _tmp5_;
						GError* _tmp6_;
						const gchar* _tmp7_;
						e = _inner_error0_;
						_inner_error0_ = NULL;
						_tmp5_ = name;
						_tmp6_ = e;
						_tmp7_ = _tmp6_->message;
						g_printerr ("unable compile %s: %s\n", _tmp5_, _tmp7_);
						_g_error_free0 (e);
					}
					__finally6:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (name);
						(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_free0_ (_tmp0_), NULL));
						return;
					}
				}
				_g_free0 (name);
			}
		}
	}
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_free0_ (_tmp0_), NULL));
}


void
dconf_compile (gchar** args,
               int args_length1,
               GError** error)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	_tmp2_ = args[2];
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp3_;
		_tmp3_ = args[3];
		_tmp1_ = _tmp3_ == NULL;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp4_;
		_tmp4_ = args[4];
		_tmp0_ = _tmp4_ != NULL;
	}
	if (_tmp0_) {
		GError* _tmp5_;
		_tmp5_ = g_error_new_literal (G_OPTION_ERROR, G_OPTION_ERROR_FAILED, "must give output file and .d dir");
		_inner_error0_ = _tmp5_;
		g_propagate_error (error, _inner_error0_);
		return;
	}
	{
		GHashTable* table = NULL;
		const gchar* _tmp6_;
		GHashTable* _tmp7_;
		gboolean should_byteswap = FALSE;
		GHashTable* _tmp8_;
		const gchar* _tmp9_;
		gboolean _tmp10_;
		_tmp6_ = args[3];
		_tmp7_ = read_directory (_tmp6_, &_inner_error0_);
		table = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch7_g_error;
		}
		should_byteswap = G_BYTE_ORDER == G_BIG_ENDIAN;
		_tmp8_ = table;
		_tmp9_ = args[2];
		_tmp10_ = should_byteswap;
		gvdb_table_write_contents (_tmp8_, _tmp9_, _tmp10_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_hash_table_unref0 (table);
			goto __catch7_g_error;
		}
		_g_hash_table_unref0 (table);
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp11_ = e->message;
		g_printerr ("%s\n", _tmp11_);
		exit (1);
		_g_error_free0 (e);
	}
	__finally7:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
}


void
dconf_update (gchar** args,
              int args_length1,
              GError** error)
{
	GError* _inner_error0_ = NULL;
	update_all ("/etc/dconf/db", &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



